# TAG Security Publications

This document lists all the publications and resources that TAG Security has produced.

| Publication | Description | Format | Link |
|-------------|--------------|--------|------|
| **Cloud Native Security Controls Catalog** | Mapping of Cloud Native Security Whitepaper and Software Supply Chain Best Practices Paper to NIST SP800-53r5 | Markdown | [Link](/community/working-groups/controls/phase-one-announcement.md) |
| | | Spreadsheet | [Link](https://docs.google.com/spreadsheets/d/1GUohOTlLw9FKUQ3O23X7ypvJLXN-B3veJGe6YE6JYfU/edit?usp=sharing) |
| **Cloud Native Security Lexicon** | Standardization of terminologies specific to Cloud Native Security | Markdown | [Link](/community/resources/security-lexicon/cloud-native-security-lexicon.md) |
| **Cloud Native Security Whitepaper** | Information about building, distributing, deploying, and running secure cloud native capabilities | Markdown (v2) | [Link](/community/resources/security-whitepaper/v2/cloud-native-security-whitepaper.md) |
| | | PDF (v2) | [Link](/community/resources/security-whitepaper/v2/CNCF_cloud-native-security-whitepaper-cn-Sept2023-v2.pdf) |
| | | Audio (v1) | [Link](https://soundcloud.com/user-769472014/sets/cncf-tag-security-cloud-native-security-whitepaper-version-v1) |
| | **Translations** | | |
| | | Portuguese (v1) | [Link](/community/resources/security-whitepaper/v1/cloud-native-security-whitepaper-brazilian-portugese.md) |
| | | Chinese (v1) | [Link](/community/resources/security-whitepaper/v1/cloud-native-security-whitepaper-simplified-chinese.md) |
| **Open and Secure - A Manual for Practicing Threat Modeling to Assess and Fortify Open Source Security** | Guide for assessing and understanding the security of open source software projects | PDF | [Link](/community/assessments/Open_and_Secure.pdf) |
| **Policy** | | | |
| | Formal Verification for Policy Configurations | Markdown | [Link](/community/working-groups/archive/policy/overview-policy-formal-verification.md) |
| | Handling build-time dependency vulnerabilities | Markdown | [Link](/community/working-groups/archive/policy/overview-policy-build-time-dependency-vulns.md) |
| **Secure Defaults: Cloud Native 8** | | Markdown | [Link](/community/resources/security-whitepaper/secure-defaults-cloud-native-8.md) |
| **Security Assessments** | Assessments of several CNCF projects | | |
| | Buildpacks | Markdown | [Link](/community/assessments/projects/buildpacks) |
| | Cloud Custodian | Markdown | [Link](/community/assessments/projects/custodian) |
| | Harbor | Markdown | [Link](/community/assessments/projects/harbor) |
| | In-toto | Markdown | [Link](/community/assessments/projects/in-toto) |
| | Keycloak | Markdown | [Link](/community/assessments/projects/keycloak) |
| | Kyverno | Markdown | [Link](/community/assessments/projects/kyverno) |
| | OPA | Markdown | [Link](/community/assessments/projects/opa) |
| | Spiffe-Spire | Markdown | [Link](/community/assessments/projects/spiffe-spire) |
| **Supply Chain Security** | | | |
| | Software Supply Chain Best Practices | Markdown | [Link](/community/working-groups/supply-chain-security/supply-chain-security-paper/sscsp.md) |
| | | PDF | [Link](/community/working-groups/supply-chain-security/supply-chain-security-paper/CNCF_SSCP_v1.pdf) |
| | Evaluating your supply chain security | Markdown | [Link](/community/working-groups/supply-chain-security/supply-chain-security-paper/secure-supply-chain-assessment.md) |
| | Secure Software Factory | Markdown | [Link](/community/working-groups/supply-chain-security/secure-software-factory/secure-software-factory.md) |
| | | PDF | [Link](/community/working-groups/supply-chain-security/secure-software-factory/Secure_Software_Factory_Whitepaper.pdf) |
| | Catalog of Supply Chain Compromises | Markdown | [Link](/community/catalog/compromises) |
| **Use Cases & Personas** | List of use cases to enable secure access, policy control, and safety for users of cloud native technology | Markdown | [Link](/community/resources/usecase-personas/README.md) |
