# Commons Working Group

## Goals

- Create a bridge for knowledge sharing between the STAG and other bodies within the Linux Foundation
- Seek opportunities to mitigate duplication of security efforts between bodies within the Linux Foundation
- Ensure hygiene recommendations for CNCF projects align closely with corresponding OpenSSF recommendations

## Scope

- Coordinate discussion between contributors from STAG and OpenSSF
- Highlight opportunities for the STAG to contribute to codebases, standards, and publications that may benefit the CNCF and/or STAG goals

## Deliverables

1. Aid in the creation of a universal open source project security baseline.
1. Contribute to the development of evaluation probes that can be used to evaluate Linux Foundation (and CNCF) projects against the universal open source project security baseline.

## Meeting Information

- **Meeting:** Every 2 weeks on Wednesday at 10:30 ET ([Calendar Invite](https://zoom-lfx.platform.linuxfoundation.org/meeting/98902119803?password=089ce577-a05d-4d3c-9caa-73f8bfd90e5c))
- **Meeting Notes:** [Google Docs](https://docs.google.com/document/d/14xJf4c4ugjwmSmk-V49-_xPNaqZe771zI9qn95TN7ws/edit)

## Contact

- **Lead:** Eddie Knight
- **STAG Rep:** Marco De Benedictis
- **Slack Channel:** [Link](https://cloud-native.slack.com/archives/C07EX4ZU15Y)
