# Software Supply Chain Security

Software Supply Chain attacks have come to the wider community's attention following a recent high-profile attack, but have been an ongoing threat for a long time. With the ever-growing importance of free and open source software, software supply chain security is crucial, particularly in cloud native environments where everything is software-defined.

## What are supply chain vulnerabilities and their implications?

The [Catalog of Supply Chain Compromises](../../catalog/compromises/) provides real-world
examples that help raise awareness and provide detailed information that
let's us understand attack vectors and consider how to mitigate potential
risk.

## On mitigating vulnerabilities

There is on-going work to establish best practices in this area. The list of
[types of supply chain compromises](../../catalog/compromises/compromise-definitions.md)
in the [catalog of supply chain compromises](../../catalog/compromises/) suggests some
mitigation techniques for the more well understood categories.

## Supply chain security paper

STAG (Security Technical Advisory Group) has put work into a comprehensive
software supply chain paper highlighting best practices for high and medium risk
environments. Please check out
[the paper](./supply-chain-security-paper/sscsp.md)
and corollary
[secure supply chain assessment document](./supply-chain-security-paper/secure-supply-chain-assessment.md)
to learn more.

For information about contributing to the document or providing feedback, please
refer to the [README](./supply-chain-security-paper/README.md).

## Meeting Information

- **Weekly Meetings:** 8:00 AM Pacific Time (US and Canada)
- **Meeting Link:** See CNCF calendar for invite
- **Meeting Notes:** [Google Docs](https://docs.google.com/document/d/170y5biX9k95hYRwprITprG6Mc9xD5glVn-4mB2Jmi2g/edit#heading=h.xkkh09c7ni6)

## Contact

- **Lead:** Marina Moore, Michael Lieberman, John Kjell
- **Slack Channel:** [Link](https://cloud-native.slack.com/archives/C01KL0B4LKC)
